# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import json

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def update_package():
    result = False
    proxies = get_proxies()

    if not proxies:
        proxies = get_proxies_from_wapt_console()
    
    git_repo = "sensu/sensu-go"
    url_api = "https://api.github.com/repos/%s/releases/latest" % git_repo   
    # Getting latest version information from official sources
    print("API used is: %s" % url_api)
    json_load = json.loads(wgets(url_api, proxies=proxies))
    version = json_load["tag_name"].replace("v","")

    url_base = "https://sensu.io/downloads"
    response = requests.get(url_base,allow_redirects=True, proxies=proxies)
    # Extract the correct div using bs_find_all
    divs = bs_find_all(response.text, "div","class","content-meta", proxies=proxies)
    msi_file = None
    for div in divs:
        if msi_file:
            break
        links = div.find_all('a', href=True)
        for link in links:
            if link['href'].endswith('.msi'):
                href = link['href']
                msi_file = href
                download_url = msi_file
                latest_bin = msi_file.split('/')[-1]
                break


    if not isfile(latest_bin):
        package_updated = True
        wget(download_url,latest_bin,proxies=proxies)

    #nettoyer les fichiers temporaires
    for f in glob.glob('*.msi'):
        if f != latest_bin:
            remove_file(f)

    version =get_version_from_binary(latest_bin)
    control.set_software_version(version)
    control.save_control_to_wapt()